Index: arch/hppa/hppa/locore.S
===================================================================
RCS file: /cvs/src/sys/arch/hppa/hppa/locore.S,v
retrieving revision 1.155
diff -u -r1.155 locore.S
--- arch/hppa/hppa/locore.S	20 Jul 2007 22:09:23 -0000	1.155
+++ arch/hppa/hppa/locore.S	25 Sep 2007 09:53:42 -0000
@@ -2771,171 +2771,23 @@
 	copy	r0, ret0
 EXIT(spstrcpy)
 
-	.import	whichqs, data
-	.import	qs, data
 /*
- * setrunqueue(struct proc *p);
- * Insert a process on the appropriate queue.  Should be called at splclock().
+ * int cpu_switchto(struct proc *old, struct proc *new)
+ * Switch from "old" proc to "new".
  */
 	.align	32
-ENTRY(setrunqueue,0)
-#ifdef DIAGNOSTIC
-	ldw	P_BACK(arg0), t1
-	comb,<>,n r0, t1, Lsetrunqueue_panic
-	ldw	P_WCHAN(arg0), t1
-	comb,<>,n r0, t1, Lsetrunqueue_panic
-	ldb	P_STAT(arg0), t1
-	comib,=,n SRUN, t1, Lsetrunqueue_ok
-Lsetrunqueue_panic
-	copy	arg0, arg1
-	ldil	L%panic, r1
-	ldil	L%Lsrqpstr, arg0
-	ldo	R%panic(r1), r1
-	ldo	R%Lsrqpstr(arg0), arg0
-	.call
-	blr	%r0, rp
-	bv,n	%r0(r1)
-	nop
-Lsrqpstr
-	.asciz	"setrunqueue(%p)"
-	.align	8
-Lsetrunqueue_ok
-#endif
-
-	ldb	P_PRIORITY(arg0), t2
-	ldil	L%qs, t4
-	extru	t2, 29, 5, t1
-	ldo	R%qs(t4), t4
-	sh3add	t1, t4, t4
-	ldil	L%whichqs, arg3
-	ldw	P_BACK(t4), t2
-	stw	t4, P_FORW(arg0)
-	stw	arg0, P_BACK(t4)
-	ldw	R%whichqs(arg3), t3
-	stw	arg0, P_FORW(t2)
-	mtctl	t1, sar
-	stw	t2, P_BACK(arg0)
-	vdepi	1, 1, t3
-	bv	0(rp)
-	stw	t3, R%whichqs(arg3)
-EXIT(setrunqueue)
-
-/*
- * remrunqueue(struct proc *p);
- * Remove a process from its queue.  Should be called at splclock().
- */
-	.align	32
-ENTRY(remrunqueue,0)
-	ldb	P_PRIORITY(arg0), t2
-	extru	t2, 29, 5, arg2
-	ldil	L%whichqs, t2
-	mtsar	arg2
-	ldw	R%whichqs(t2), t3
-
-#ifdef DIAGNOSTIC
-	bvb,<,n	t3, remrunqueue_ok
-
-Lremrunqueue_panic
-	copy	arg0, arg1
-	ldil	L%panic, r1
-	ldil	L%Lrrqpstr, arg0
-	ldo	R%panic(r1), r1
-	ldo	R%Lrrqpstr(arg0), arg0
-	.call
-	blr	%r0, rp
-	bv,n	%r0(r1)
-	nop
-
-Lrrqpstr
-	.asciz	"remrunqueue(%p), bit=%x"
-	.align	8
-remrunqueue_ok
-#endif
-	ldw	P_BACK(arg0), t4
-	stw	r0, P_BACK(arg0)
-	ldw	P_FORW(arg0), arg0
-	stw	arg0, P_FORW(t4)
-	vdepi	0, 1, t3
-	sub,<>	t4, arg0, r0
-	stw	t3, R%whichqs(t2)
-	bv	0(rp)
-	stw	t4, P_BACK(arg0)
-EXIT(remrunqueue)
-
-/*
- * cpu_switch()
- * Find the highest priority process and resume it.
- */
-	.align	32
-ENTRY(cpu_switch,128)
-	ldil	L%cpl, t1
-	ldw	R%cpl(t1), ret0
+ENTRY(cpu_switchto,128)
 	copy	r3, r1
 	stw	rp, HPPA_FRAME_CRP(sp)
 	copy	sp, r3
-	stw	ret0, HPPA_FRAME_SL(sp)
 	stwm	r1, HPPA_FRAME_SIZE+20*4(sp)
 
-	/*
-	 * Clear curproc so that we don't accumulate system time while idle.
-	 */
-	ldil	L%curproc, t1
-	ldw	R%curproc(t1), arg2
-	b	switch_search
-	stw	r0, R%curproc(t1)
-	/* remain on the old (curproc)'s stack until we have a better choice */
-
-cpu_idle
-	copy	r0, arg0
-	break	HPPA_BREAK_KERNEL, HPPA_BREAK_SPLLOWER
-	.import uvm, data
-	ldil	L%(uvm + PAGE_IDLE_ZERO), t3
-	ldw	R%(uvm + PAGE_IDLE_ZERO)(t3), t4
-	sub,<>	r0, t4, r0
-	b	cpu_loop
-
-	stw	arg2, 4(r3)
-	ldil	L%uvm_pageidlezero, t1
-	ldo	R%uvm_pageidlezero(t1), t2
-	.call
-	ble	0(sr0, t2)
-	copy	r31, rp
-
-	ldw	HPPA_FRAME_SL(r3), ret0
-	ldw	4(r3), arg2
-
-cpu_loop
-	ldil	L%cpl, arg0
-	stw	ret0, R%cpl(arg0)
-
-switch_search
-	/*
-	 * t1:   &whichqs
-	 * arg2: old curproc
-	 *
-	 */
-	ldil	L%whichqs, t1
-	ldw	R%whichqs(t1), t3
-	comb,=,n r0, t3, cpu_idle
-	copy	r0, arg0
-
-	ldi	0, t4
-getbit
-	mtsar	t4
-	bvb,>=,n t3, getbit
-	ldo	1(t4), t4
-
-	ldil	L%qs, t2
-	ldo	R%qs(t2), t2
-	sh3add	t4, t2, t2
-
-	ldw	P_FORW(t2), arg1
 #ifdef DIAGNOSTIC
-	comb,<>	t2, arg1, link_ok
+	b	kstack_check
 	nop
 switch_error
-	copy	t4, arg1
-	copy	t2, arg2
+	copy	arg1, arg2
+	copy	arg0, arg1
 	ldil	L%panic, r1
 	ldil	L%Lcspstr, arg0
 	ldo	R%panic(r1), r1
@@ -2945,61 +2797,48 @@
 	bv,n	%r0(r1)
 	nop
 Lcspstr
-	.asciz	"cpu_switch: bit=%x, q/p=%p"
+	.asciz	"cpu_switch:old=%p, new=%p"
 	.align	8
-link_ok
-#endif
-	ldil	L%want_resched, t4
-	stw	r0, R%want_resched(t4)
-
-	ldw	P_FORW(arg1), arg0
-	stw	arg0, P_FORW(t2)
-	stw	t2, P_BACK(arg0)
-	stw	r0, P_BACK(arg1)
-
-	vdepi	0, 1, t3
-	sub,<>	t2, arg0, r0
-	stw	t3, R%whichqs(t1)
-
-	/* don't need &whichqs (t1) starting here */
-#ifdef DIAGNOSTIC
+kstack_check
 	ldw	P_WCHAN(arg1), t1
 	comb,<>,n r0, t1, switch_error
-	copy	arg1, t2
+	nop
 	ldb	P_STAT(arg1), t1
 	comib,<>,n SRUN, t1, switch_error
-	copy	arg1, t2
+	nop
 	/*
-	 * Either we must be switching to the same process, or
-	 * the new process' kernel stack must be reasonable.
+	 * The new process' kernel stack must be reasonable.
 	 */
-	comb,=,n arg1, arg2, kstack_ok
-	ldw     P_ADDR(arg1), arg0
-	ldw	U_PCB+PCB_KSP(arg0), t1
-	ldo     NBPG(arg0), arg0
-	comb,>>,n arg0, t1, switch_error
-	copy    arg1, t2
-	sub     t1, arg0, t1
-	ldil    L%USPACE, arg0
-	ldo     R%USPACE(arg0), arg0
-	comb,<<=,n arg0, t1, switch_error
-	copy    arg1, t2
+	ldw     P_ADDR(arg1), arg2
+	ldw	U_PCB+PCB_KSP(arg2), t1
+	ldo     NBPG(arg2), arg2
+	comb,>>,n arg2, t1, switch_error
+	nop
+	sub     t1, arg2, t1
+	ldil    L%USPACE, arg2
+	ldo     R%USPACE(arg2), arg2
+	comb,<<=,n arg2, t1, switch_error
+	nop
 kstack_ok
 #endif
+	ldil	L%want_resched, t4
+	stw	r0, R%want_resched(t4)
+
+	/* Record new proc. */
 	ldi	SONPROC, t1
 	stb	t1, P_STAT(arg1)
-	/* Skip context switch if same process. */
-	comb,=,n arg1, arg2, switch_return
+	ldil	L%curproc, t1
+	stw	arg1, R%curproc(t1)
 
 	/* If old process exited, don't bother. */
-	comb,=,n r0, arg2, switch_exited
+	comb,=,n r0, arg0, switch_exited
 
 	/*
 	 * 2. save old proc context
 	 *
-	 * arg2: old proc
+	 * arg0: old proc
 	 */
-	ldw	P_ADDR(arg2), t1
+	ldw	P_ADDR(arg0), t1
 	/* save callee-save registers */
 	stw	r4,   1*4(r3)
 	stw	sp, U_PCB+PCB_KSP(t1)
@@ -3021,13 +2860,14 @@
 	stw	r0, HPPA_FRAME_ARG(1)(sp)	/* say no trampoline */
 	sync
 
-	/* don't need old curproc (arg2) starting from here */
+	/* don't need old curproc (arg0) starting from here */
 switch_exited
 	/*
 	 * 3. restore new proc context
 	 *
 	 * arg1: new proc
 	 */
+	/* XXX disable interrupts? */
 	ldw	P_ADDR(arg1), t2
 	ldw	P_MD_REGS(arg1), t1
 	ldw	U_PCB+PCB_KSP(t2), sp
@@ -3036,11 +2876,12 @@
 	ldw	TF_CR9(t1), t3
 	mtctl	t2, cr30
 	mtctl	t3, pidr2
+	/* XXX enable interrupts? */
 	ldo	-(HPPA_FRAME_SIZE+20*4)(sp), r3
 	ldw	HPPA_FRAME_ARG(0)(sp), arg0
 	ldw	HPPA_FRAME_ARG(1)(sp), t4 /* in case we're on trampoline */
 	sub,=	r0, t4, r0
-	b	switch_gonnajump
+	b	switch_return
 	ldw	 1*4(r3), r4
 	ldw	 2*4(r3), r5
 	ldw	 3*4(r3), r6
@@ -3056,21 +2897,31 @@
 	ldw	13*4(r3), r16
 	ldw	14*4(r3), r17
 	ldw	15*4(r3), r18
-switch_gonnajump
-	ldw	HPPA_FRAME_SL(r3), ret0
-	ldil	L%cpl, t1
-	stw	ret0, R%cpl(t1)
-	sync
 
 switch_return
-	ldil	L%curproc, t1
-	stw	arg1, R%curproc(t1)
 	ldw	HPPA_FRAME_CRP(r3), rp
 	bv	0(rp)
 	ldwm	-(HPPA_FRAME_SIZE+20*4)(sp), r3
-EXIT(cpu_switch)
+EXIT(cpu_switchto)
+
+LEAF_ENTRY(cpu_idle_enter)
+	bv	0(rp)
+	nop
+EXIT(cpu_idle_enter)
+
+LEAF_ENTRY(cpu_idle_cycle)
+	bv	0(rp)
+	nop
+EXIT(cpu_idle_cycle)
+
+LEAF_ENTRY(cpu_idle_leave)
+	bv	0(rp)
+	nop
+EXIT(cpu_idle_leave)
 
 ENTRY(switch_trampoline,0)
+	ldil	L%cpl, t1
+	stw	r0, R%cpl(t1)
 	.call
 	blr	r0, rp
 	bv,n	r0(t4)
Index: arch/hppa/hppa/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/hppa/hppa/vm_machdep.c,v
retrieving revision 1.61
diff -u -r1.61 vm_machdep.c
--- arch/hppa/hppa/vm_machdep.c	20 Jun 2007 17:29:34 -0000	1.61
+++ arch/hppa/hppa/vm_machdep.c	25 Sep 2007 09:53:43 -0000
@@ -160,12 +160,11 @@
 		tf->tf_sp = (register_t)stack;
 
 	/*
-	 * Build stack frames for the cpu_switch & co.
+	 * Build stack frames for the cpu_switchto & co.
 	 */
 	osp = sp + HPPA_FRAME_SIZE;
 	*(register_t*)(osp - HPPA_FRAME_SIZE) = 0;
 	*(register_t*)(osp + HPPA_FRAME_CRP) = (register_t)&switch_trampoline;
-	*(register_t*)(osp + HPPA_FRAME_SL) = 0;	/* cpl */
 	*(register_t*)(osp) = (osp - HPPA_FRAME_SIZE);
 
 	sp = osp + HPPA_FRAME_SIZE + 20*4; /* frame + calee-save registers */
@@ -187,8 +186,8 @@
 		fpu_curpcb = 0;
 	}
 
-	exit2(p);
-	cpu_switch(p);
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 void
Index: arch/hppa/include/cpu.h
===================================================================
RCS file: /cvs/src/sys/arch/hppa/include/cpu.h,v
retrieving revision 1.51
diff -u -r1.51 cpu.h
--- arch/hppa/include/cpu.h	20 Jul 2007 22:12:39 -0000	1.51
+++ arch/hppa/include/cpu.h	25 Sep 2007 09:53:43 -0000
@@ -64,6 +64,7 @@
 
 #ifndef _LOCORE
 #ifdef _KERNEL
+#include <sys/queue.h>
 #include <sys/sched.h>
 
 struct cpu_info {
Index: arch/i386/i386/cpu.c
===================================================================
RCS file: /cvs/src/sys/arch/i386/i386/cpu.c,v
retrieving revision 1.25
diff -u -r1.25 cpu.c
--- arch/i386/i386/cpu.c	29 May 2007 18:18:20 -0000	1.25
+++ arch/i386/i386/cpu.c	25 Sep 2007 09:53:43 -0000
@@ -274,6 +274,7 @@
 		identifycpu(ci);
 		cpu_init(ci);
 
+		sched_init_cpu(ci);
 #if NLAPIC > 0
 		/*
 		 * Enable local apic
@@ -295,6 +296,7 @@
 		cpu_alloc_ldt(ci);
 		ci->ci_flags |= CPUF_PRESENT | CPUF_AP;
 		identifycpu(ci);
+		sched_init_cpu(ci);
 		ci->ci_next = cpu_info_list->ci_next;
 		cpu_info_list->ci_next = ci;
 		ncpus++;
@@ -463,6 +465,9 @@
 		    ci->ci_dev.dv_xname, ci->ci_cpuid);
 	microuptime(&ci->ci_schedstate.spc_runtime);
 	splx(s);
+
+	SCHED_LOCK(s);
+	cpu_switchto(NULL, sched_chooseproc());
 }
 
 void
Index: arch/i386/i386/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/i386/i386/genassym.cf,v
retrieving revision 1.26
diff -u -r1.26 genassym.cf
--- arch/i386/i386/genassym.cf	3 Apr 2007 10:14:47 -0000	1.26
+++ arch/i386/i386/genassym.cf	25 Sep 2007 09:53:43 -0000
@@ -88,8 +88,6 @@
 # proc fields and values
 struct	proc
 member	p_addr
-member	p_back
-member	p_forw
 member	p_priority
 member	p_stat
 member	p_wchan
Index: arch/i386/i386/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/i386/i386/locore.s,v
retrieving revision 1.114
diff -u -r1.114 locore.s
--- arch/i386/i386/locore.s	29 May 2007 23:02:02 -0000	1.114
+++ arch/i386/i386/locore.s	25 Sep 2007 09:53:44 -0000
@@ -1295,279 +1295,52 @@
 	ret
 
 /*****************************************************************************/
-
-/*
- * The following primitives manipulate the run queues.
- * whichqs tells which of the 32 queues qs have processes in them.
- * Setrq puts processes into queues, Remrq removes them from queues.
- * The running process is on no queue, other processes are on a queue
- * related to p->p_pri, divided by 4 actually to shrink the 0-127 range
- * of priorities into the 32 available queues.
- */
-	.globl	_C_LABEL(whichqs),_C_LABEL(qs),_C_LABEL(uvmexp),_C_LABEL(panic)
-/*
- * setrunqueue(struct proc *p);
- * Insert a process on the appropriate queue.  Should be called at splclock().
- */
-NENTRY(setrunqueue)
-	movl	4(%esp),%eax
-#ifdef DIAGNOSTIC
-	cmpl	$0,P_BACK(%eax)	# should not be on q already
-	jne	1f
-	cmpl	$0,P_WCHAN(%eax)
-	jne	1f
-	cmpb	$SRUN,P_STAT(%eax)
-	jne	1f
-#endif /* DIAGNOSTIC */
-	movzbl	P_PRIORITY(%eax),%edx
-	shrl	$2,%edx
-	btsl	%edx,_C_LABEL(whichqs)		# set q full bit
-	leal	_C_LABEL(qs)(,%edx,8),%edx	# locate q hdr
-	movl	P_BACK(%edx),%ecx
-	movl	%edx,P_FORW(%eax)	# link process on tail of q
-	movl	%eax,P_BACK(%edx)
-	movl	%eax,P_FORW(%ecx)
-	movl	%ecx,P_BACK(%eax)
-	ret
-#ifdef DIAGNOSTIC
-1:	pushl	$2f
-	call	_C_LABEL(panic)
-	/* NOTREACHED */
-2:	.asciz	"setrunqueue"
-#endif /* DIAGNOSTIC */
-
-/*
- * remrunqueue(struct proc *p);
- * Remove a process from its queue.  Should be called at splclock().
- */
-NENTRY(remrunqueue)
-	movl	4(%esp),%ecx
-	movzbl	P_PRIORITY(%ecx),%eax
-#ifdef DIAGNOSTIC
-	shrl	$2,%eax
-	btl	%eax,_C_LABEL(whichqs)
-	jnc	1f
-#endif /* DIAGNOSTIC */
-	movl	P_BACK(%ecx),%edx	# unlink process
-	movl	$0,P_BACK(%ecx)		# zap reverse link to indicate off list
-	movl	P_FORW(%ecx),%ecx
-	movl	%ecx,P_FORW(%edx)
-	movl	%edx,P_BACK(%ecx)
-	cmpl	%ecx,%edx		# q still has something?
-	jne	2f
-#ifndef DIAGNOSTIC
-	shrl	$2,%eax
-#endif
-	btrl	%eax,_C_LABEL(whichqs)		# no; clear bit
-2:	ret
+		
 #ifdef DIAGNOSTIC
-1:	pushl	$3f
+NENTRY(switch_error1)
+	pushl	%edi
+	pushl	$1f
 	call	_C_LABEL(panic)
 	/* NOTREACHED */
-3:	.asciz	"remrunqueue"
-#endif /* DIAGNOSTIC */
-
-#if NAPM > 0
-	.globl _C_LABEL(apm_cpu_idle),_C_LABEL(apm_cpu_busy)
-#endif
-/*
- * When no processes are on the runq, cpu_switch() branches to here to wait for
- * something to come ready.
- */
-ENTRY(idle)
-	/* Skip context saving if we have none. */
-	testl %esi,%esi
-	jz	1f
-
-	/*
-	 * idling:	save old context.
-	 *
-	 * Registers:
-	 *   %eax, %ebx, %ecx - scratch
-	 *   %esi - old proc, then old pcb
-	 *   %edi - idle pcb
-	 *   %edx - idle TSS selector
-	 */
-
-	pushl	%esi
-	call	_C_LABEL(pmap_deactivate)	# pmap_deactivate(oldproc)
-	addl	$4,%esp
-
-	movl	P_ADDR(%esi),%esi
-
-	/* Save stack pointers. */
-	movl	%esp,PCB_ESP(%esi)
-	movl	%ebp,PCB_EBP(%esi)
-
-	/* Find idle PCB for this CPU */
-#ifndef MULTIPROCESSOR
-	movl	$_C_LABEL(proc0),%ebx
-	movl	P_ADDR(%ebx),%edi
-	movl	P_MD_TSS_SEL(%ebx),%edx
-#else
-	movl	CPUVAR(IDLE_PCB), %edi
-	movl	CPUVAR(IDLE_TSS_SEL), %edx
-#endif
-
-	/* Restore the idle context (avoid interrupts) */
-	cli
-
-	/* Restore stack pointers. */
-	movl	PCB_ESP(%edi),%esp
-	movl	PCB_EBP(%edi),%ebp
-
-
-	/* Switch address space. */
-	movl	PCB_CR3(%edi),%ecx
-	movl	%ecx,%cr3
-
-	/* Switch TSS. Reset "task busy" flag before loading. */
-	movl	CPUVAR(GDT), %eax
-	andl	$~0x0200,4-SEL_KPL(%eax,%edx,1)
-	ltr	%dx
-
-	/* We're always in the kernel, so we don't need the LDT. */
-
-	/* Restore cr0 (including FPU state). */
-	movl	PCB_CR0(%edi),%ecx
-	movl	%ecx,%cr0
-
-	/* Record new pcb. */
-	SET_CURPCB(%edi)
-
-	xorl	%esi,%esi
-	sti
-
-1:
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)	
-	call	_C_LABEL(sched_unlock_idle)
-#endif
-
-	movl	$IPL_NONE,CPL		# spl0()
-	call	_C_LABEL(Xspllower)	# process pending interrupts
-	jmp	_C_LABEL(idle_start)
-
-ENTRY(idle_loop)
-#if NAPM > 0
-	call	_C_LABEL(apm_cpu_idle)
-#else
-#if NPCTR > 0
-	addl	$1,_C_LABEL(pctr_idlcnt)
-	adcl	$0,_C_LABEL(pctr_idlcnt)+4
-#endif
-	sti
-	hlt
-#endif
-ENTRY(idle_start)
-	cli
-	cmpl	$0,_C_LABEL(whichqs)
-	jz	_C_LABEL(idle_loop)
-
-ENTRY(idle_exit)
-	movl	$IPL_HIGH,CPL		# splhigh
-	sti
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)	
-	call	_C_LABEL(sched_lock_idle)
-#endif
-#if NAPM > 0
-	call	_C_LABEL(apm_cpu_busy)
-#endif
-	jmp	switch_search
-		
-#ifdef DIAGNOSTIC
-NENTRY(switch_error)
+1:	.asciz	"cpu_switch1 %p"
+NENTRY(switch_error2)
+	pushl	%edi
 	pushl	$1f
 	call	_C_LABEL(panic)
 	/* NOTREACHED */
-1:	.asciz	"cpu_switch"
+1:	.asciz	"cpu_switch2 %p"
 #endif /* DIAGNOSTIC */
 
 /*
- * cpu_switch(void);
- * Find a runnable process and switch to it.  Wait if necessary.  If the new
- * process is the same as the old one, we short-circuit the context save and
- * restore.
+ * cpu_switchto(struct proc *old, struct proc *new)
+ * Switch from the "old" proc to the "new" proc. If "old" is NULL, we
+ * don't need to bother saving old context.
  */
-ENTRY(cpu_switch)
+ENTRY(cpu_switchto)
 	pushl	%ebx
 	pushl	%esi
 	pushl	%edi
-	pushl	CPL
 
-	movl	CPUVAR(CURPROC), %esi
+	movl	16(%esp), %esi
+	movl	20(%esp), %edi
 
-	/*
-	 * Clear curproc so that we don't accumulate system time while idle.
-	 * This also insures that schedcpu() will move the old process to
-	 * the correct queue if it happens to get called from the spllower()
-	 * below and changes the priority.  (See corresponding comment in
-	 * userret()).
-	 */
-	movl	$0, CPUVAR(CURPROC)
-
-switch_search:
-	/*
-	 * First phase: find new process.
-	 *
-	 * Registers:
-	 *   %eax - queue head, scratch, then zero
-	 *   %ebx - queue number
-	 *   %ecx - cached value of whichqs
-	 *   %edx - next process in queue
-	 *   %esi - old process
-	 *   %edi - new process
-	 */
+	xorl	%eax, %eax
 
-	/* Wait for new process. */
-	movl	_C_LABEL(whichqs),%ecx
-	bsfl	%ecx,%ebx		# find a full q
-	jz	_C_LABEL(idle)		# if none, idle
-	leal	_C_LABEL(qs)(,%ebx,8),%eax	# select q
-	movl	P_FORW(%eax),%edi	# unlink from front of process q
-#ifdef	DIAGNOSTIC
-	cmpl	%edi,%eax		# linked to self (i.e. nothing queued)?
-	je	_C_LABEL(switch_error)	# not possible
-#endif /* DIAGNOSTIC */
-	movl	P_FORW(%edi),%edx
-	movl	%edx,P_FORW(%eax)
-	movl	%eax,P_BACK(%edx)
-
-	cmpl	%edx,%eax		# q empty?
-	jne	3f
-
-	btrl	%ebx,%ecx		# yes, clear to indicate empty
-	movl	%ecx,_C_LABEL(whichqs)	# update q status
-
-3:	xorl	%eax, %eax
-	/* We just did it. */
-	movl	$0, CPUVAR(RESCHED)
+	movl	%eax, CPUVAR(RESCHED)
 
 #ifdef	DIAGNOSTIC
 	cmpl	%eax,P_WCHAN(%edi)	# Waiting for something?
-	jne	_C_LABEL(switch_error)	# Yes; shouldn't be queued.
+	jne	_C_LABEL(switch_error1)	# Yes; shouldn't be queued.
 	cmpb	$SRUN,P_STAT(%edi)	# In run state?
-	jne	_C_LABEL(switch_error)	# No; shouldn't be queued.
+	jne	_C_LABEL(switch_error2)	# No; shouldn't be queued.
 #endif /* DIAGNOSTIC */
 
-	/* Isolate process.  XXX Is this necessary? */
-	movl	%eax,P_BACK(%edi)
-
-	/* Record new process. */
-	movb	$SONPROC,P_STAT(%edi)	# p->p_stat = SONPROC
-	movl	CPUVAR(SELF), %ecx
-	movl	%edi, CPUVAR(CURPROC)
-	movl	%ecx, P_CPU(%edi)
-
-	/* Skip context switch if same process. */
-	cmpl	%edi,%esi
-	je	switch_return
-
 	/* If old process exited, don't bother. */
 	testl	%esi,%esi
 	jz	switch_exited
 
 	/*
-	 * Second phase: save old context.
+	 * Save old context.
 	 *
 	 * Registers:
 	 *   %eax, %ecx - scratch
@@ -1597,18 +1370,19 @@
 
 	/* No interrupts while loading new state. */
 	cli
+
+	/* Record new process. */
+	movl	CPUVAR(SELF), %ebx
+	movl	%edi, CPUVAR(CURPROC)
+	movb	$SONPROC, P_STAT(%edi)
+	movl	%ebx, P_CPU(%edi)
+
 	movl	P_ADDR(%edi),%esi
 
 	/* Restore stack pointers. */
 	movl	PCB_ESP(%esi),%esp
 	movl	PCB_EBP(%esi),%ebp
 
-#if 0
-	/* Don't bother with the rest if switching to a system process. */
-	testl	$P_SYSTEM,P_FLAG(%edi)
-	jnz	switch_restored
-#endif
-
 	/*
 	 * Activate the address space.  We're curproc, so %cr3 will
 	 * be reloaded, but we're not yet curpcb, so the LDT won't
@@ -1639,7 +1413,6 @@
 	lldt	%dx
 #endif /* USER_LDT */
 
-switch_restored:
 	/* Restore cr0 (including FPU state). */
 	movl	PCB_CR0(%esi),%ecx
 #ifdef MULTIPROCESSOR
@@ -1661,103 +1434,29 @@
 	/* Interrupts are okay again. */
 	sti
 
-switch_return:
-#if 0
-	pushl	%edi
-	movl	CPUVAR(NAME), %ebx
-	leal	CPU_INFO_NAME(%ebx),%ebx
-	pushl	%ebx
-	pushl	$1f
-	call	_C_LABEL(printf)
-	addl	$0xc,%esp
-#endif
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	call    _C_LABEL(sched_unlock_idle)
-#endif
-	/*
-	 * Restore old cpl from stack.  Note that this is always an increase,
-	 * due to the spl0() on entry.
-	 */
-	popl	CPL
-
-	movl	%edi,%eax		# return (p);
 	popl	%edi
 	popl	%esi
 	popl	%ebx
 	ret
-1:	.asciz	"%s: scheduled %x\n"
-/*
- * switch_exit(struct proc *p);
- * Switch to the appropriate idle context (proc0's if uniprocessor; the cpu's if
- * multiprocessor) and deallocate the address space and kernel stack for p.
- * Then jump into cpu_switch(), as if we were in the idle proc all along.
- */
-#ifndef MULTIPROCESSOR
-	.globl	_C_LABEL(proc0)
-#endif
-ENTRY(switch_exit)
-	movl	4(%esp),%edi		# old process
-#ifndef MULTIPROCESSOR
-	movl	$_C_LABEL(proc0),%ebx
-	movl	P_ADDR(%ebx),%esi
-	movl	P_MD_TSS_SEL(%ebx),%edx
-#else
-	movl	CPUVAR(IDLE_PCB), %esi
-	movl	CPUVAR(IDLE_TSS_SEL), %edx
-#endif
 
-	/* In case we fault... */
-	movl	$0, CPUVAR(CURPROC)
-
-	/* Restore the idle context. */
-	cli
-
-	/* Restore stack pointers. */
-	movl	PCB_ESP(%esi),%esp
-	movl	PCB_EBP(%esi),%ebp
-
-	/* Load TSS info. */
-	movl	CPUVAR(GDT), %eax
-
-	/* Switch address space. */
-	movl	PCB_CR3(%esi),%ecx
-	movl	%ecx,%cr3
-
-	/* Switch TSS. */
-	andl	$~0x0200,4-SEL_KPL(%eax,%edx,1)
-	ltr	%dx
-
-	/* We're always in the kernel, so we don't need the LDT. */
-
-	/* Clear segment registers; always null in proc0. */
-	xorl	%ecx,%ecx
-	movw	%cx,%gs
-
-	/* Point to cpu_info */
-	movl	$GSEL(GCPU_SEL, SEL_KPL),%ecx
-	movw	%cx,%fs
-
-	/* Restore cr0 (including FPU state). */
-	movl	PCB_CR0(%esi),%ecx
-	movl	%ecx,%cr0
-
-	/* Record new pcb. */
-	SET_CURPCB(%esi)
+ENTRY(cpu_idle_enter)
+	ret
 
-	/* Interrupts are okay again. */
+ENTRY(cpu_idle_cycle)
+#if NAPM > 0
+	call	_C_LABEL(apm_cpu_idle)
+#else
+#if NPCTR > 0
+	addl	$1,_C_LABEL(pctr_idlcnt)
+	adcl	$0,_C_LABEL(pctr_idlcnt)+4
+#endif
 	sti
+	hlt
+#endif
+	ret
 
-	/*
-	 * Schedule the dead process's vmspace and stack to be freed.
-	 */
-	pushl	%edi			/* exit2(p) */
-	call	_C_LABEL(exit2)
-	addl	$4,%esp
-
-	/* Jump into cpu_switch() with the right state. */
-	xorl	%esi,%esi
-	movl	$0, CPUVAR(CURPROC)
-	jmp	switch_search
+ENTRY(cpu_idle_leave)
+	ret
 
 /*
  * savectx(struct pcb *pcb);
Index: arch/i386/i386/mptramp.s
===================================================================
RCS file: /cvs/src/sys/arch/i386/i386/mptramp.s,v
retrieving revision 1.8
diff -u -r1.8 mptramp.s
--- arch/i386/i386/mptramp.s	20 Feb 2007 21:15:01 -0000	1.8
+++ arch/i386/i386/mptramp.s	25 Sep 2007 09:53:44 -0000
@@ -249,9 +249,7 @@
 	HALTT(0x30,%ecx)
 	pushl	%ecx
 	call	_C_LABEL(cpu_hatch)
-	HALT(0x33)
-	xorl	%esi,%esi
-	jmp	_C_LABEL(idle_start)
+	/* NOTREACHED */
 
 	.data
 _C_LABEL(mp_pdirpa):
Index: arch/i386/i386/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/i386/i386/vm_machdep.c,v
retrieving revision 1.52
diff -u -r1.52 vm_machdep.c
--- arch/i386/i386/vm_machdep.c	27 May 2007 20:59:25 -0000	1.52
+++ arch/i386/i386/vm_machdep.c	25 Sep 2007 09:53:44 -0000
@@ -126,7 +126,6 @@
 		tf->tf_esp = (u_int)stack + stacksize;
 
 	sf = (struct switchframe *)tf - 1;
-	sf->sf_ppl = 0;
 	sf->sf_esi = (int)func;
 	sf->sf_ebx = (int)arg;
 	sf->sf_eip = (int)proc_trampoline;
@@ -151,7 +150,7 @@
 #endif
 
 	pmap_deactivate(p);
-	switch_exit(p);
+	sched_exit(p);
 }
 
 void
Index: arch/i386/include/frame.h
===================================================================
RCS file: /cvs/src/sys/arch/i386/include/frame.h,v
retrieving revision 1.8
diff -u -r1.8 frame.h
--- arch/i386/include/frame.h	27 Nov 2006 18:04:28 -0000	1.8
+++ arch/i386/include/frame.h	25 Sep 2007 09:53:44 -0000
@@ -106,7 +106,6 @@
  * Stack frame inside cpu_switch()
  */
 struct switchframe {
-	int	sf_ppl;
 	int	sf_edi;
 	int	sf_esi;
 	int	sf_ebx;
Index: arch/luna88k/luna88k/locore.S
===================================================================
RCS file: /cvs/src/sys/arch/luna88k/luna88k/locore.S,v
retrieving revision 1.13
diff -u -r1.13 locore.S
--- arch/luna88k/luna88k/locore.S	12 Jan 2007 21:41:53 -0000	1.13
+++ arch/luna88k/luna88k/locore.S	25 Sep 2007 09:53:45 -0000
@@ -150,8 +150,8 @@
 	 * Now we will compete with the other processors to see which one
 	 * will be elected as the main one.
 	 */
-	or.u	r11, r0,  hi16(_ASM_LABEL(cpu_mutex))
-	or	r11, r11, lo16(_ASM_LABEL(cpu_mutex))
+	or.u	r11, r0,  hi16(_C_LABEL(cpu_mutex))
+	or	r11, r11, lo16(_C_LABEL(cpu_mutex))
 1:
 	FLUSH_PIPELINE
 	or	r22, r0,  1
@@ -282,15 +282,6 @@
 	bsr.n	_C_LABEL(secondary_pre_main)	/* set cpu number */
 	 or	r31, r31, lo16(_ASM_LABEL(slavestack_end))
 
-	/*
-	 * Release cpu_mutex; we have a race with other secondary CPUs here
-	 * because the stack has not been switched yet. However, since our
-	 * interrupts are disabled, the worst we can get is an NMI, and, oh
-	 * well, it means we're in deep trouble anyway.
-	 */
-	or.u	r10, r0, hi16(_ASM_LABEL(cpu_mutex))
-	st	r0, r10, lo16(_ASM_LABEL(cpu_mutex))
-
 	ldcr	r2, CPU
 1:
 	ld	r3, r2, CI_CURPCB
@@ -299,13 +290,6 @@
 	br.n	_C_LABEL(secondary_main)
 	 add	r31, r3, USIZE 		/* switch to idle stack */
 
-	/*
-	 * At this point, the CPU has been correctly initialized and has
-	 * identified itself on the console.
-	 * All it needs now is to jump to the idle loop and wait for work to
-	 * be offered.
-	 */
-	br	_ASM_LABEL(cpu_switch_search)
 #else
 
 	/*
@@ -315,15 +299,6 @@
 
 #endif	/* MULTIPROCESSOR */
 
-	/*
-	 * Release the cpu_mutex; secondary processors will now have their
-	 * chance to initialize.
-	 */
-GLOBAL(cpu_boot_secondary_processors)
-	or.u	r2,  r0,  hi16(_ASM_LABEL(cpu_mutex))
-	jmp.n	r1
-	 st	r0,  r2,  lo16(_ASM_LABEL(cpu_mutex))
-
 /*
  * void delay(int count)
  *
@@ -382,10 +357,6 @@
 
 /* The first processor that XMEMs this becomes the master */
 ASLOCAL(master_mpu)
-	word 0
-
-/* XMEM spin lock -- controls access to master_mpu */
-ASLOCAL(cpu_mutex)
 	word 0
 
 #if defined(DDB) || NKSYMS > 0
Index: arch/luna88k/luna88k/machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/luna88k/luna88k/machdep.c,v
retrieving revision 1.44
diff -u -r1.44 machdep.c
--- arch/luna88k/luna88k/machdep.c	6 Jun 2007 17:15:12 -0000	1.44
+++ arch/luna88k/luna88k/machdep.c	25 Sep 2007 09:53:46 -0000
@@ -85,6 +85,7 @@
 #include <machine/cmmu.h>
 #include <machine/cpu.h>
 #include <machine/kcore.h>
+#include <machine/lock.h>
 #include <machine/reg.h>
 #include <machine/trap.h>
 #include <machine/m88100.h>
@@ -105,6 +106,7 @@
 
 caddr_t	allocsys(caddr_t);
 void	consinit(void);
+void	cpu_boot_secondary_processors(void);
 void	dumpconf(void);
 void	dumpsys(void);
 int	getcpuspeed(void);
@@ -183,6 +185,8 @@
 struct vm_map *exec_map = NULL;
 struct vm_map *phys_map = NULL;
 
+__cpu_simple_lock_t cpu_mutex = __SIMPLELOCK_UNLOCKED;
+
 /*
  * Declare these as initialized data so we can patch them.
  */
@@ -756,6 +760,16 @@
 #ifdef MULTIPROCESSOR
 
 /*
+ * Release the cpu_mutex; secondary processors will now have their
+ * chance to initialize.
+ */
+void
+cpu_boot_secondary_processors()
+{
+	__cpu_simple_unlock(&cpu_mutex);
+}
+
+/*
  * Secondary CPU early initialization routine.
  * Determine CPU number and set it, then allocate the idle pcb (and stack).
  *
@@ -793,17 +807,18 @@
 secondary_main()
 {
 	struct cpu_info *ci = curcpu();
+	int s;
 
 	cpu_configuration_print(0);
+	sched_init_cpu(ci);
 	ncpus++;
+	__cpu_simple_unlock(&cpu_mutex);
 
 	microuptime(&ci->ci_schedstate.spc_runtime);
+	ci->ci_curproc = NULL;
 
-	/*
-	 * Upon return, the secondary cpu bootstrap code in locore will
-	 * enter the idle loop, waiting for some food to process on this
-	 * processor.
-	 */
+	SCHED_LOCK(s);
+	cpu_switchto(NULL, sched_chooseproc());
 }
 
 #endif	/* MULTIPROCESSOR */
@@ -966,7 +981,6 @@
 	cpuid_t cpu;
 	extern void m8820x_initialize_cpu(cpuid_t);
 	extern void m8820x_set_sapr(cpuid_t, apr_t);
-	extern void cpu_boot_secondary_processors(void);
 
 	cmmu = &cmmu8820x;
 
Index: arch/m68k/include/cpu.h
===================================================================
RCS file: /cvs/src/sys/arch/m68k/include/cpu.h,v
retrieving revision 1.17
diff -u -r1.17 cpu.h
--- arch/m68k/include/cpu.h	22 May 2007 10:31:08 -0000	1.17
+++ arch/m68k/include/cpu.h	25 Sep 2007 09:53:46 -0000
@@ -66,6 +66,7 @@
 
 #ifdef _KERNEL
 #ifndef _LOCORE
+#include <sys/queue.h>
 #include <sys/sched.h>
 
 struct cpu_info {
@@ -268,6 +269,9 @@
  * This is used during profiling to integrate system time.
  */
 #define	PROC_PC(p)	(((struct trapframe *)((p)->p_md.md_regs))->tf_pc)
+
+#define	cpu_idle_enter()	do { /* nothing */ } while (0)
+#define	cpu_idle_leave()	do { /* nothing */ } while (0)
 
 #endif /* _KERNEL */
 
Index: arch/m68k/m68k/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/m68k/m68k/genassym.cf,v
retrieving revision 1.12
diff -u -r1.12 genassym.cf
--- arch/m68k/m68k/genassym.cf	15 May 2007 13:46:22 -0000	1.12
+++ arch/m68k/m68k/genassym.cf	25 Sep 2007 09:53:46 -0000
@@ -71,15 +71,10 @@
 
 # proc fields and values
 struct	proc
-member	p_forw
-member	p_back
-member	p_priority
 member	p_stat
-member	p_wchan
 member	p_vmspace
 member	p_addr
 
-export	SRUN
 export	SONPROC
 
 # contexts
Index: arch/m88k/include/cpu.h
===================================================================
RCS file: /cvs/src/sys/arch/m88k/include/cpu.h,v
retrieving revision 1.22
diff -u -r1.22 cpu.h
--- arch/m88k/include/cpu.h	19 May 2007 20:34:32 -0000	1.22
+++ arch/m88k/include/cpu.h	25 Sep 2007 09:53:46 -0000
@@ -58,6 +58,7 @@
 #include <machine/pcb.h>
 #include <machine/psl.h>
 #include <machine/intr.h>
+#include <sys/queue.h>
 #include <sys/sched.h>
 
 #if defined(MULTIPROCESSOR)
@@ -164,6 +165,8 @@
  */
 #define	cpu_exec(p)		do { /* nothing */ } while (0)
 #define	cpu_wait(p)		do { /* nothing */ } while (0)
+
+#define	cpu_idle_cycle()	do { /* nothing */ } while (0)
 
 #if defined(MULTIPROCESSOR)
 #include <sys/lock.h>
Index: arch/m88k/m88k/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/m88k/m88k/genassym.cf,v
retrieving revision 1.8
diff -u -r1.8 genassym.cf
--- arch/m88k/m88k/genassym.cf	12 May 2007 19:59:52 -0000	1.8
+++ arch/m88k/m88k/genassym.cf	25 Sep 2007 09:53:46 -0000
@@ -49,15 +49,11 @@
 
 # proc fields and values
 struct	proc
-member	p_forw
-member	p_back
 member	p_addr
 member	p_stat
-member	p_wchan
 member	p_cpu
 member	P_ASTPENDING	p_md.md_astpending
 
-export	SRUN
 export	SONPROC
 
 # cpu fields
Index: arch/m88k/m88k/m88k_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/m88k/m88k/m88k_machdep.c,v
retrieving revision 1.21
diff -u -r1.21 m88k_machdep.c
--- arch/m88k/m88k/m88k_machdep.c	29 May 2007 18:10:42 -0000	1.21
+++ arch/m88k/m88k/m88k_machdep.c	25 Sep 2007 09:53:46 -0000
@@ -202,50 +202,6 @@
 	return (ENAMETOOLONG);
 }
 
-void
-setrunqueue(p)
-	struct proc *p;
-{
-	struct prochd *q;
-	struct proc *oldlast;
-	int which = p->p_priority >> 2;
-
-#ifdef DIAGNOSTIC
-	if (p->p_back != NULL)
-		panic("setrunqueue %p", p);
-#endif
-	q = &qs[which];
-	whichqs |= 1 << which;
-	p->p_forw = (struct proc *)q;
-	p->p_back = oldlast = q->ph_rlink;
-	q->ph_rlink = p;
-	oldlast->p_forw = p;
-}
-
-/*
- * Remove process p from its run queue, which should be the one
- * indicated by its priority.  Calls should be made at splstatclock().
- */
-void
-remrunqueue(vp)
-	struct proc *vp;
-{
-	struct proc *p = vp;
-	int which = p->p_priority >> 2;
-	struct prochd *q;
-
-#ifdef DIAGNOSTIC
-	if ((whichqs & (1 << which)) == 0)
-		panic("remrq %p", p);
-#endif
-	p->p_forw->p_back = p->p_back;
-	p->p_back->p_forw = p->p_forw;
-	p->p_back = NULL;
-	q = &qs[which];
-	if (q->ph_link == (struct proc *)q)
-		whichqs &= ~(1 << which);
-}
-
 #ifdef DDB
 int longformat = 1;
 void
